import irc.bot
import irc.strings
from irc.client import ip_numstr_to_quad, ip_quad_to_numstr
import ssl
import random
import openai

class IRCBot(irc.bot.SingleServerIRCBot):
    def __init__(self, channel, nickname, server, port=6697):
        ssl_factory = irc.connection.Factory(wrapper=ssl.wrap_socket)
        irc.bot.SingleServerIRCBot.__init__(self, [(server, port)], nickname, nickname, connect_factory=ssl_factory)
        self.channel = channel
        self.nickname = nickname

    def on_welcome(self, connection, event):
        connection.join(self.channel)

    def on_privmsg(self, connection, event):
        self.respond(event)

    def on_pubmsg(self, connection, event):
        self.respond(event)

    def respond(self, event):
        message = event.arguments[0]
        if event.type == "privmsg":
            source = event.source.nick
        else:
            source = self.channel

        if self.nickname.lower() in message.lower():
            response = generate_response(message)
            self.send_message(source, response)

    def send_message(self, target, message):
        self.connection.privmsg(target, message)

def generate_response(message):
    # Replace 'YOUR_API_KEY' with your actual OpenAI API key
    openai.api_key = 'your-api-key'
    response = openai.Completion.create(
        engine="text-davinci-003",
        prompt=message,
        max_tokens=50,
        temperature=0.7,
        n=1,
        stop=None,
        timeout=10
    )
    return response.choices[0].text.strip()

def main():
    channel = "#texto-plano"
    nickname = "kernel"
    server = "irc.tilde.chat"
    port = 6697

    bot = IRCBot(channel, nickname, server, port)
    bot.start()

if __name__ == "__main__":
    main()

